const express = require('express');
const router = express.Router();
const multer = require('multer');
const authorize = require('../../../../middlewares/authorize-sapps');
const employmentTypeService = require('./employmentType.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new employmentType
 * @param {Object} req.body - The employmentType data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created employmentType
 */
function create(req, res, next) {
    employmentTypeService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all employmentTypes
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of employmentTypes
 */
function getAll(req, res, next) {
    employmentTypeService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of employmentType objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of employmentType objects
 */
function option(req, res, next) {
    employmentTypeService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of employmentTypes matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of employmentTypes
 */
function count(req, res, next) {
    employmentTypeService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing employmentType
 * @param {number} req.params.id - The employmentType ID to be updated
 * @param {Object} req.body - The employmentType data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated employmentType
 */
function update(req, res, next) {
    employmentTypeService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a employmentType
 * @param {number} req.params.id - The employmentType ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    employmentTypeService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
